<?php
/**
 *
 * @category        modules
 * @package         miniform
 * @author          Ruud Eisinga
 * @link			http://www.dev4me.nl/modules-snippets/opensource/miniform/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x
 * @requirements    PHP 5.2.2 and higher
 * @version         0.3
 * @lastmodified    feb 22, 2013
 *
 */

if(defined('WB_PATH') == false) { exit("Cannot access this file directly"); }
if(!file_exists(WB_PATH.'/modules/miniform/languages/'.LANGUAGE.'.php')) {
	require_once(WB_PATH.'/modules/miniform/languages/EN.php');
} else {
	require_once(WB_PATH.'/modules/miniform/languages/'.LANGUAGE.'.php');
}
require_once ('functions.php');
require_once(WB_PATH.'/include/captcha/captcha.php');

$mf = new mform();

$get_settings = $database->query("SELECT * FROM ".TABLE_PREFIX."mod_miniform WHERE section_id = '$section_id'");
$settings = $get_settings->fetchRow();
$form = $settings['template'];
$email = $settings['email'];
$subject = $settings['subject'];
$successpage = $settings['successpage'];

$template = $mf->get_template('form_'.$form);
$message = "";
$message_class = "hidden";
$form_class = "";
$use_captcha = ( strpos($template,"{CAPTCHA}")==false ) ? false : true;
$captcha_class = $use_captcha ? "":"hidden";
$captcha = "";
$asp = "";

if ( isset($_POST) && is_array($_POST) && count($_POST) > 0 ) { 
	$all_required = true;
	if ($use_captcha) {
		if(isset($_POST['captcha']) AND $_POST['captcha'] != ''){
			if(!isset($_SESSION['captcha']) OR $_POST['captcha'] != $_SESSION['captcha']) {
				$var[] = "{CAPTCHA_ERROR}"; $value[] = " missing";
				$all_required = false;
			}
		} else {
			$var[] = "{CAPTCHA_ERROR}"; $value[] = " missing";
			$all_required = false;
		}
	}			
	$mailmessage = $mf->get_template('email');
	$mailmessage = $mf->add_template($mailmessage, "{SUBJECT}", $subject);
	$field_val = $mf->get_template('email_field_value');
	$tmp_fv = '';
	$aspdetect = false;
	foreach ($_POST as $key => $rawpost) {
		$post = $mf->safe_get_post($key);
		$required = false;
		$mailmessage = $mf->add_template($mailmessage, '{'.strtoupper($key).'}', $post);
		if(substr($key,0,3)=="mf_") {
			$key =  substr($key,3);
			if (substr($key,0,2)=="r_") {
				$required = true;
				$key =  substr($key,2);
			}
			
			$var[] = "{".strtoupper($key)."}"; $value[] = $post;
			$var[] = "{".strtoupper($key.'_'.$post)."}"; $value[] = " checked='checked' ";
			if(is_array($rawpost)) {
				$tmppost = explode(',',$post);
				foreach($tmppost as $tmpdata) {
					$var[] = "{".strtoupper($key.'_'.$tmpdata)."}"; $value[] = " checked='checked' ";
				}
			}
			if($required && trim($post) == '') {
				$var[] = "{".strtoupper($key)."_ERROR}"; $value[] = " missing";
				$all_required = false;
			}
			$key = ucwords($key);
			$key = str_replace("_"," ",$key);
			$post = nl2br($post);
			if($post) {
				$tmp_fv .= $mf->add_template($field_val, array('{FIELD}','{VALUE}'), array($key,$post));
			}
		} elseif(substr($key,0,3)=="my_" && $post !== '') {
			$aspdetect = true;
		}
	}
	$mailmessage = $mf->add_template($mailmessage, '{MAILMESSAGE}', $tmp_fv);
	if(!$aspdetect) {
		if ($all_required) {
			// store message in database
			$data['message_id'] = 0;
			$data['section_id'] = $section_id;
			$data['data'] = addslashes($mailmessage); 
			$data['submitted_when'] = time();
			$mf->update_record('mod_miniform_data', 'message_id', $data );
			// send message by mail
			if($mf->mail ($email, $email, $subject, $mailmessage)) {
				if($successpage) {
					$page_link = $mf->page($successpage);
					if(headers_sent()) {
						echo '<script type="text/javascript">window.location = "'.$page_link.'"</script>';
					} else {
						die(header('Location: '.$page_link , TRUE , 301));
					}
				}
				$message = $MF['THANKYOU'];
				$message_class = "ok";
				$form_class = "hidden";
			}
		} else {
			$message = $MF['NOTALL'];
			$message_class = "error";
		}
	}
}

if (ENABLED_ASP) {
	$asp = 	'<div style="top: -2000px; position: absolute; height:0px; overflow: hidden">'."\n\t\t".
			'<label for="ucomp">CompanyName</label><input autocomplete="off" type="text" id="ucomp" name="my_company" /><br/>'."\n\t\t".
			'<label for="uname">Username</label><input autocomplete="off" type="text" id="uname" name="my_name" /><br/>'."\n\t\t".
			'<label for="umail">Email</label><input autocomplete="off" type="text" id="umail" name="my_email" /><br/>'."\n\t\t".
			'</div>';
}
if ($use_captcha) {
	ob_start();
	call_captcha();
	$captcha = ob_get_contents();
	ob_end_clean();
}


$var[] = "{ASPFIELDS}";	$value[] = $asp;
$var[] = "{CAPTCHA}";	$value[] = $captcha;
$var[] = "{STATUSMESSAGE}";	$value[] = $message;
$var[] = "{CAPTCHA_CLASS}";	$value[] = $captcha_class;
$var[] = "{MESSAGE_CLASS}";	$value[] = $message_class;
$var[] = "{FORM_CLASS}";	$value[] = $form_class;
$var[] = "{PAGE_ID}";	$value[] = $page_id;
$var[] = "{SECTION_ID}";$value[] = $section_id;
$var[] = "{DATE}";$value[] = date( DATE_FORMAT , time()+TIMEZONE );
$var[] = "{TIME}";$value[] = date( TIME_FORMAT , time()+TIMEZONE );
$template = $mf->add_template($template, $var, $value);

//clean unused fields in the template
$template = preg_replace('#\{[A-Za-z_][A-Za-z_0-9]*?\}#s', '', $template); 
echo $template;

